#ifndef __CAMERADEVICE_H__
#define __CAMERADEVICE_H__

#include <stdio.h>
#include <stdlib.h>

struct RGBImage {
  int width, height, bpp;
  unsigned char* data;
  unsigned long timestamp;
  
  RGBImage() { width=0; height=0; bpp=3; data=NULL; timestamp=0; }
  ~RGBImage() { if (data) free(data); data=NULL; } 
  void alloc_mem(int w, int h) { width=w; height=h; data=(unsigned char*)malloc(width*height*bpp); }
  void free_mem() { if (data) free(data); data=NULL; }
  void savePPM(const char *filename);
  bool loadPPM(const char *filename);
};

class CameraDevice {
public:
	char cameraid[33];
	RGBImage image;

	CameraDevice() { }
	CameraDevice(int w, int h) { image.alloc_mem(w,h); }
	virtual ~CameraDevice() { }
	virtual void init() { }
	virtual bool ready() = 0;
	virtual bool getFrame() = 0;
	virtual void done() { }
};

unsigned long getTimeStamp();

#endif
