/*
 * findBall.cpp
 *
 *  Created on: Nov 23, 2012
 *      Author: morpheus
 */

#include "findBall.h"

findBall::findBall() {
	// TODO Auto-generated constructor stub
}

int hmax = 190;
int hmin = 170;
int s = 140;
int v = 90;

void trackbarThresHmax(int n) {
	hmax = n;
}

void trackbarThresHmin(int n) {
	hmin = n;
}

void trackbarThresS(int n) {
	s = n;
}

void trackbarThresV(int n) {
	v = n;
}

void onMouseHSV(int event, int x, int y, int flag, void *param) {
	switch (event) {
		case CV_EVENT_LBUTTONDOWN:
		{
			IplImage *frame = (IplImage *) param;
			cv::Mat originalImg(frame);
			cv::Mat hsv(originalImg.size(), originalImg.type());
			cv::cvtColor(originalImg, hsv, CV_BGR2HSV);
			std::vector<cv::Mat> planes;
			cv::split(hsv, planes);
			std::cout << "X: " << x << " Y: " << y << std::endl;
			std::cout << "H: " << (int)(planes[0].at<uchar>(y,x)) << " S: "
					<< (int)(planes[1].at<uchar>(y,x)) << " V: " << (int)(planes[2].at<uchar>(y,x)) << std::endl;
			break;
		}
		case CV_EVENT_RBUTTONDOWN:
		{
			break;
		}
	}
}


findBall::findBall(IplImage *frame, IplImage *currentFg) {
	this->frame = frame;
	this->fg = currentFg;
	red = cvCreateImage(cvSize(640,480),IPL_DEPTH_8U,1);
	cvZero(red);
	//isOnField = false;
    //cvNamedWindow("Red Image", CV_WINDOW_AUTOSIZE);
    //cvNamedWindow("ImageHSV", CV_WINDOW_AUTOSIZE);
    //cvSetMouseCallback("ImageHSV", onMouseHSV, this->frame);
    //cvCreateTrackbar("Hmax","Red Image",&hmax,255,trackbarThresHmax);
    //cvCreateTrackbar("Hmin","Red Image",&hmin,255,trackbarThresHmin);
    //cvCreateTrackbar("S","Red Image",&s,255,trackbarThresS);
    //cvCreateTrackbar("V","Red Image",&v,255,trackbarThresV);
}

findBall::~findBall() {
	cvReleaseImage(&red);
}

bool findBall::process() {
	findRed();
	//cvShowImage("Red Image", red);
    return findBlob();
    //findBlob();
    //cvShowImage("Red Image", red);
    //cvShowImage("ImageHSV", frame);
}

void findBall::findRed() {
	cv::Mat originalImg(frame);
	cv::Mat hsv(originalImg.size(), originalImg.type());
	cv::cvtColor(originalImg, hsv, CV_BGR2HSV);
	std::vector<cv::Mat> planes;
	cv::split(hsv, planes);

	for(int i = 0; i < originalImg.rows; ++i) {
		for(int j = 0;  j < originalImg.cols; ++j) {
			//search for RED in HSV
			if(	(int)(planes[0].at<uchar>(i,j)) < hmax &&
					(int)(planes[0].at<uchar>(i,j)) > hmin &&
				(int)(planes[1].at<uchar>(i,j)) > s 		&&
				(int)(planes[2].at<uchar>(i,j)) > v	)
			{
				red->imageData[j + (int)frame->width * ( i % (int)frame->height)] = 255;
			} else {
				red->imageData[j + (int)frame->width * ( i % (int)frame->height)] = 0;
			}
		}
	}
}

bool findBall::findBlob() {
	CBlobResult blobs = CBlobResult( red, NULL, 0 );
	CBlob currentBlob;
	CBlobGetArea getArea;
	cv::Point2i tl, br;
	std::vector<cv::Point2i>::iterator it;
	int numBlobs = blobs.GetNumBlobs();
	for(int i = 0; i < numBlobs; ++i) {
		currentBlob = blobs.GetBlob(i);

		 int max_x = (int)currentBlob.MaxX();
         int min_x = (int)currentBlob.MinX();
         int max_y = (int)currentBlob.MaxY();
         int min_y = (int)currentBlob.MinY();

		if(getArea(currentBlob) > 50) {
			for(int i = min_y; i < max_y; ++i) {
				for(int j = min_x; j < max_x; ++j) {
					if((uchar)red->imageData[j + (int)frame->width * ( i % (int)frame->height)] == 255) {
						fg->imageData[j + (int)frame->width * ( i % (int)frame->height)] = 255;
					}
				}
			}
			return true;
		}
	}
	return false;
}


/*bool findBall::findBlob() {
	CBlobResult blobs = CBlobResult( red, NULL, 0 );
	CBlobResult refineBlobs;
	CBlob currentBlob;
	CBlobGetArea getArea;
	cv::Point2i tl, br;
	std::vector<cv::Point2i>::iterator it;
	bool found = false;
	int numBlobs = blobs.GetNumBlobs();
	for(int i = 0; i < numBlobs; ++i) {
		currentBlob = blobs.GetBlob(i);
		if(getArea(currentBlob) > 10) {
			ball = currentBlob;
			tl.x = currentBlob.MinX()-5;
			tl.y = currentBlob.MinY()-5;
			br.x = currentBlob.MaxX()+5;
		    br.y =  currentBlob.MaxY()+5;
			cvRectangle(frame, cvPoint(tl.x, tl.y), cvPoint( br.x, br.y), cvScalar(0, 255, 255), 2);
			history.push_back(cv::Point2i((tl.x + (br.x - tl.x)/2), (tl.y + (br.y - tl.y)/2)));
			found = true;
			break;
		}
	}
	if(found) {
		for(it = history.begin(); it != history.end()-1; ++it) {
			cvCircle(frame, cvPoint((*it).x, (*it).y), 3, cvScalar(0, 120, 120), -1);
		}
		found = false;
		return true;
	}

	for(it = history.begin(); it != history.end(); ++it) {
		cvCircle(frame, cvPoint((*it).x, (*it).y), 3, cvScalar(0, 120, 120), -1);
	}

	return false;
}*/
