/*
 *  grabber.h
 *
 *  Author: Domenico Bloisi
 *  domenicobloisi@yahoo.com
 *  Copyright 2010
 */

#ifndef GRABBER_H_
#define GRABBER_H_

//C
#include <stdio.h>
#include <stdlib.h>

//time
#ifdef __linux__
#include <sys/timeb.h>
#include <sys/time.h>
#include <time.h>
#else
#include <sys/timeb.h>
#include <sys/types.h>
#endif

// OpenCV
#include <opencv2/core/core.hpp>
#include <opencv2/imgproc/imgproc.hpp>
#include <opencv2/legacy/compat.hpp>
#include <opencv2/imgproc/imgproc_c.h>
#include <opencv2/highgui/highgui.hpp>
//#include "svsclass.h"

#include <iostream>
using namespace std;

class Grabber
{
	public:
		int prev_counter;
		int prev_offset;

		int frameNumber; // frame number
		int width, height;

		IplImage *frame;
		IplImage *prevFrame;

//		svsStereoImage *svsstereoimage;

		unsigned long timestamp;
		unsigned long prevTimestamp;

		short *disparity;

		CvCapture* capture;

		double fps;

		cv::Mat disparityImage;


	public:
		Grabber(){};
		virtual ~Grabber(){};
		virtual bool getData() = 0;
		virtual unsigned long getTimestamp() = 0;
		virtual unsigned long getPrevTimestamp() = 0;
		virtual int getWidth() = 0;
		virtual int getHeight() = 0;
		virtual double getFps() = 0;
		virtual void reset() = 0;
		virtual cv::Mat getDepth16bit() = 0;
};


#endif /*GRABBER_H_*/

