/*
 * player.cpp
 *
 *  Created on: Nov 17, 2012
 *      Author: Andrea Pennisi
 */

#include "player.h"
#include <string>
#include <iostream>

#define threshold 30

player::player() {
	// TODO Auto-generated constructor stub
}

player::player(const cv::Point2i topLeft, const cv::Point2i bottomRight,
		IplImage *frame, const svs3Dpoint *adjustedPts3D) {

		this->topLeft = topLeft;
		this->bottomRight = bottomRight;


		this->bottomRight3D.x = bottomRight.x;
		this->bottomRight3D.y = bottomRight.y;
		this->bottomRight3D.z = adjustedPts3D[bottomRight.x + 640 * ( bottomRight.y % 480)].Z;
		this->topLeft3D.x = topLeft.x;
		this->topLeft3D.y = topLeft.y;
		this->topLeft3D.z = adjustedPts3D[topLeft.x + 640 * ( topLeft.y % 480)].Z;
		this->frame = frame;
}

player::~player() {
	//cvReleaseImage(&frame);
}

void player::setRole(const std::vector<previousPosition> startedPosition, std::vector<previousPosition>& lastPosition) {
	previousPosition p;
	if(lastPosition.size() != 3) {
		int pos = topLeft.x + ((bottomRight.x - topLeft.x)/2);
		for(unsigned int i = 0; i < startedPosition.size(); ++i) {
			//in questo caso pos.y è il maxX
			if( pos <= startedPosition[i].pos.y ) {
				p.role = role = startedPosition[i].role;
				//CALCOLO IL BARICENTRO CORRENT
				p.pos3D.x = topLeft3D.x + ((bottomRight3D.x - topLeft3D.x)/2);
				p.pos3D.y = topLeft3D.y + ((bottomRight3D.y - topLeft3D.y)/2);
				p.pos3D.z = topLeft3D.z + (abs(bottomRight3D.z - topLeft3D.z)/2);
				lastPosition.push_back(p);
				break;
			}
		}
	} else {
		//CALCOLO IL BARICENTRO CORRENTE
		int x =topLeft3D.x + ((bottomRight3D.x - topLeft3D.x)/2);
		int y =topLeft3D.y + ((bottomRight3D.y - topLeft3D.y)/2);
		int z =topLeft3D.z + (abs(bottomRight3D.z - topLeft3D.z)/2);
		for(unsigned int i = 0; i < lastPosition.size(); ++i) {
			if(x <= (lastPosition[i].pos3D.x + threshold) && x >= (lastPosition[i].pos3D.x - threshold) &&
					y <= (lastPosition[i].pos3D.y + threshold) && y >= (lastPosition[i].pos3D.y - threshold) &&
					z <= (lastPosition[i].pos3D.z + threshold) && z >= (lastPosition[i].pos3D.z - threshold)) {
				 role = lastPosition[i].role;
				 lastPosition[i].pos3D.x = x;
				 lastPosition[i].pos3D.y = y;
				 lastPosition[i].pos3D.z = z;
				 break;
			}
		}
	}
}


void player::drawBoundingBox(const svs3Dpoint *adjustedPts3D, svsStereoImage* svsstereoimage, const IplImage *fgImage) {
	std::vector<cv::Point2i> points;
	CvFont font;
	cvInitFont(&font, CV_FONT_HERSHEY_SIMPLEX, 0.4, 0.4, 0, 1);
	cvPutText(frame, role.c_str(), cvPoint(topLeft.x,topLeft.y-10), &font, CV_RGB(255, 255, 255));
	if(strcmp(role.c_str(),"defender") == 0) {

		cvRectangle(frame, cvPoint(topLeft.x, topLeft.y), cvPoint(bottomRight.x, bottomRight.y), cvScalar(255, 0, 0), 2);
		double x3D, y3D, z3D;
		float x, y;
		for(int i = 0; i < 480; ++i) {
			if(adjustedPts3D[bottomRight.x + 640 * ( i % 480)].A != 0) {
				x3D = adjustedPts3D[bottomRight.x + 640 * ( i % 480)].X;
				z3D = adjustedPts3D[bottomRight.x + 640 * ( i % 480)].Z;
				y3D = adjustedPts3D[bottomRight.x + 640 * ( i % 480)].Y;
				svsProject3D(&x, &y, x3D, y3D, z3D, &svsstereoimage->sp, svsLEFT);
				points.push_back(cv::Point2i(x, y));
			}
		}
		if(points.size() >= 2) {
			double m;
			int x1, x2;
			m = (points[points.size()-1].x == points[0].x) ? 0 :
								(points[points.size()-1].y - points[0].y) / (points[points.size()-1].x - points[0].x);
			x1 = (m == 0)? points[0].x : (120 - points[0].y) / m + points[0].x;
			x2 = (m == 0)? points[0].x : (480 - points[0].y) / m + points[0].x;
			cvLine(frame, cvPoint(x1, 120), cvPoint(x2, 480), cvScalar(255, 0, 0), 2);
//			for(int i = 120; i < 480; ++i) {
//				x1 = (m == 0) ? bottomRight.x : (120 - points[0].y) / m + points[0].x;
//				if((uchar)fgImage->imageData[x1 + 640 * ( i % 480)] != 255) {
//					cvCircle(frame, cvPoint(x1, i), 1, cvScalar(255, 0, 0), -1);
//				}
//			}
		}

	} else if(strcmp(role.c_str(), "forward") == 0) {
		std::cout << "size: " << points.size() << std::endl;
		cvRectangle(frame, cvPoint(topLeft.x, topLeft.y), cvPoint(bottomRight.x, bottomRight.y), cvScalar(0, 0, 255), 2);
		double x3D, y3D, z3D;
		float x, y;
		for(int i = 0; i < 480; ++i) {
			if(adjustedPts3D[topLeft.x + 640 * ( i % 480)].A != 0) {
				x3D = adjustedPts3D[topLeft.x + 640 * ( i % 480)].X;
				z3D = adjustedPts3D[topLeft.x + 640 * ( i % 480)].Z;
				y3D = adjustedPts3D[topLeft.x + 640 * ( i % 480)].Y;
				svsProject3D(&x, &y, x3D, y3D, z3D, &svsstereoimage->sp, svsLEFT);
				points.push_back(cv::Point2i(x, y));
			}
		}
		if(points.size() >= 2) {
			double m;
			int x1, x2;
			m = (points[points.size()-1].x == points[0].x) ? 0 :
						(points[points.size()-1].y - points[0].y) / (points[points.size()-1].x - points[0].x);
			x1 = (m == 0)? points[0].x : (120 - points[0].y) / m + points[0].x;
			x2 = (m == 0)? points[0].x : (480 - points[0].y) / m + points[0].x;
			cvLine(frame, cvPoint(x1, 120), cvPoint(x2, 480), cvScalar(0, 0, 255), 2);
//			for(int i = 120; i < 480; ++i) {
//				x1 = (m == 0) ? points[0].x : (120 - points[0].y) / m + points[0].x;
//				std::cout << "x1: " << x1  << "points[0].y: " << points[0].y << " m: " << m << std::endl;
//				if((uchar)fgImage->imageData[x1 + 640 * ( i % 480)] != 255) {
//					cvCircle(frame, cvPoint(x1, i), 1, cvScalar(0, 0, 255), -1);
//				}
//			}
		}
	} else {
		cvRectangle(frame, cvPoint(topLeft.x, topLeft.y), cvPoint(bottomRight.x, bottomRight.y), cvScalar(255, 0, 0), 2);
	}
}

player* player::findPlayer(std::string role, std::vector<player*> Players) {
	std::vector<player*>::iterator it;
	for(it = Players.begin(); it != Players.end(); ++it) {
		if(strcmp((*it)->getRole().c_str(), role.c_str()) == 0) {
			return (*it);
		}
	}
}

void player::drawBlobInPlanView(const svs3Dpoint *adjustedPts3D, IplImage *planview,
		const double planViewScale, const double planViewTranslation, std::vector<player*> Players) {

	std::vector<player*>::iterator it;

	CvFont font;
	cvInitFont(&font, CV_FONT_HERSHEY_SIMPLEX, 0.6, 0.6, 0, 1);

	int x = -1;
	int y = -1;
	cv::Point2i center;
	double heightThresholdPlayer = -1;
	int heightThresholdCounter = -1;

	//PLANVIEW
	int px = -1;
	int py = -1;
	for(int i = 0; i < 640*480; ++i) {
		if(adjustedPts3D[i].A != 0) {
			px = 2*(adjustedPts3D[i].X + planViewTranslation) * planViewScale;
			py = 2*(480 - ((adjustedPts3D[i].Z + planViewTranslation) * planViewScale));
			if(px >= 70 && py >= 50)
				cvCircle(planview,cvPoint(px,py), 1,  cvScalar(120, 120, 120), -1);
		}
	}

	CvScalar color = cvScalar(255, 255, 255);
	//Linea Centrocampo
	cvLine(planview, cvPoint(395,50), cvPoint(395, 480), color, 3);
	//Linea superiore
	cvLine(planview, cvPoint(70,50), cvPoint(640, 50), color, 3);
	//Linea Laterale
	cvLine(planview, cvPoint(70,50), cvPoint(70, 480), color, 3);
	//Porta
	//Linea piccola alta
	cvLine(planview, cvPoint(70,140), cvPoint(140, 140), color, 3);
	//Linea piccola bassa
	cvLine(planview, cvPoint(70,430), cvPoint(140, 430), color, 3);
	//Linea Lunga
	cvLine(planview, cvPoint(140, 140), cvPoint(140, 430), color, 3);
	//Cerchio centrocampo
	cvCircle(planview, cvPoint(395,280), 60, color, 3);
	cvCircle(planview, cvPoint(395,280), 5, color, -1);


	for(it = Players.begin(); it != Players.end(); ++it) {
		x = (*it)->getTopLeft().x + ((*it)->getBottomRight().x - (*it)->getTopLeft().x)/2;
		y = (*it)->getTopLeft().y + ((*it)->getBottomRight().y - (*it)->getTopLeft().y)/2;

		center.x = 2*(adjustedPts3D[x + 640 * ( y % 480)].X + planViewTranslation) * planViewScale;
		center.y = 2*(480 - ((adjustedPts3D[x + 640 * ( y % 480)].Z + planViewTranslation) * planViewScale));


		//TROVO LA MEDIA DELL'ALTEZZA DEL GIOCATORE
		heightThresholdPlayer = 0;
		heightThresholdCounter = 0;

		for(int i = (*it)->getTopLeft().y; i < (*it)->getBottomRight().y; ++i) {
			for(int j = (*it)->getTopLeft().x; j < (*it)->getBottomRight().x; ++j) {
				if(adjustedPts3D[j + 640 * ( i % 480)].A != 0) {
					heightThresholdPlayer += adjustedPts3D[j + 640 * ( i % 480)].Z;
					++heightThresholdCounter;
				}
			}
		}

		heightThresholdPlayer /= heightThresholdCounter;

		heightThresholdCounter *= 0.5;

		for(int i = (*it)->getTopLeft().y; i < (*it)->getBottomRight().y; ++i) {
			for(int j = (*it)->getTopLeft().x; j < (*it)->getBottomRight().x; ++j) {
				if(adjustedPts3D[j + 640 * ( i % 480)].A != 0 &&
						adjustedPts3D[j + 640 * ( i % 480)].Z < heightThresholdPlayer) {

					px = 2*(adjustedPts3D[j + 640 * ( i % 480)].X + planViewTranslation) * planViewScale;
					py = 2*(480 - ((adjustedPts3D[j + 640 * ( i % 480)].Z + planViewTranslation) * planViewScale));

					if(strcmp((*it)->getRole().c_str(), "defender") == 0) {
						cvCircle(planview,cvPoint(px,py), 1,  cvScalar(255, 0, 0), -1);
					} else if (strcmp((*it)->getRole().c_str(), "forward") == 0) {
						cvCircle(planview,cvPoint(px,py), 1,  cvScalar(0, 0, 255), -1);
					} else if (strcmp((*it)->getRole().c_str(), "goalkeeper") == 0) {
						cvCircle(planview,cvPoint(px,py), 1,  cvScalar(255, 0, 0), -1);
					} else {
						std::cout << "Error Planview Player Color" << std::endl;
						//abort();
					}


				}
			}
		}





		//Aggiungo nome ruolo giocatore
		cvPutText(planview, (*it)->getRole().c_str(), cvPoint(center.x,center.y-20), &font, CV_RGB(0, 0, 0));
	}

}

bool player::checkOffside(std::vector<player*> Players, findBall &ball) {
	CBlob ballBlob = ball.getBlob();
	int x = ballBlob.MinX();
	int y = ballBlob.MaxY();
	int distance = std::sqrt(pow((x - player::findPlayer("forward", Players)->getBottomRight().x),2) +
			pow((y - player::findPlayer("forward", Players)->getBottomRight().y),2));

	if((player::findPlayer("defender", Players)->getTopLeft().x - player::findPlayer("forward", Players)->getTopLeft().x) > 10 &&
			distance < abs(player::findPlayer("defender", Players)->getTopLeft().x - player::findPlayer("defender", Players)->getBottomRight().x) &&
			player::findPlayer("goalkeeper", Players)->getBottomRight().x < player::findPlayer("forward", Players)->getTopLeft().x) {
		player::findPlayer("forward", Players)->setStatus(true);
		return true;
	}
	return false;
}
