/*
 *  stereofilegrabber.h
 *
 *  Author: Domenico Bloisi
 *  domenicobloisi@yahoo.com
 *  Copyright 2012
 */

#ifndef STEREOFILEGRABBER_H_
#define STEREOFILEGRABBER_H_

#include "grabber.h"
#include "FileVIDStereoDevice.h"

class StereoFileGrabber: public Grabber
{
	private:
		double time_scale;
		FileVIDStereoDevice fdev;
		StereoDevice *sdev;

	public:
		StereoFileGrabber(const char *fn, const char *fini, int prev_offset = 1);
		virtual ~StereoFileGrabber();
		virtual bool getData();
		int getWidth(){return width;};
		int getHeight(){return height;};
		virtual unsigned long getTimestamp();
		virtual unsigned long getPrevTimestamp();
		double getFps(){return fps;};
		void reset(){ };
		inline virtual cv::Mat getDepth16bit() { return cv::Mat(); }
};


#endif /*STEREOFILEGRABBER_H_*/

